diff -ruN qmail-1.03-orig/case_startb.c qmail-1.03-ldap-20060201-orig/case_startb.c
--- qmail-1.03-orig/case_startb.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/case_startb.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,62 @@
+/*
+ * Copyright (c) 2003-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+/* based on case_starts.c by D.J. Bernstein */
+#include "case.h"
+
+int case_startb(const char *s, unsigned int len, const char *t)
+{
+	unsigned char x;
+	unsigned char y;
+
+	for (;;) {
+		y = *t++ - 'A';
+		if (y <= 'Z' - 'A')
+			y += 'a';
+		else
+			y += 'A';
+		if (!y)
+			return (1);
+		if (!len)
+			return (0);
+		--len;
+		x = *s++ - 'A';
+		if (x <= 'Z' - 'A')
+			x += 'a';
+		else
+			x += 'A';
+		if (x != y)
+			return (0);
+	}
+}
+
diff -ruN qmail-1.03-orig/case_starts.c qmail-1.03-ldap-20060201-orig/case_starts.c
--- qmail-1.03-orig/case_starts.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/case_starts.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,8 +1,8 @@
 #include "case.h"
 
 int case_starts(s,t)
-register char *s;
-register char *t;
+register const char *s;
+register const char *t;
 {
   register unsigned char x;
   register unsigned char y;
diff -ruN qmail-1.03-orig/cdb.c qmail-1.03-ldap-20060201-orig/cdb.c
--- qmail-1.03-orig/cdb.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/cdb.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,164 @@
+/* Public domain. */
+
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <sys/mman.h>
+#include <unistd.h>
+
+#include "byte.h"
+#include "error.h"
+#include "seek.h"
+#include "uint32.h"
+
+#include "cdb.h"
+
+static void uint32_unpack(const unsigned char *buf, uint32 *u)
+{
+  uint32 num;
+  num = buf[3]; num <<= 8;
+  num += buf[2]; num <<= 8;
+  num += buf[1]; num <<= 8;
+  num += buf[0];
+
+  *u = num;
+}
+
+
+
+void cdb_free(struct cdb *c)
+{
+  if (c->map) {
+    munmap(c->map,c->size);
+    c->map = 0;
+  }
+}
+
+void cdb_findstart(struct cdb *c)
+{
+  c->loop = 0;
+}
+
+void cdb_init(struct cdb *c,int fd)
+{
+  struct stat st;
+  char *x;
+
+  cdb_free(c);
+  cdb_findstart(c);
+  c->fd = fd;
+
+  if (fstat(fd,&st) == 0)
+    if (st.st_size <= 0xffffffff) {
+      x = mmap(0,st.st_size,PROT_READ,MAP_SHARED,fd,0);
+      if (x + 1) {
+	c->size = st.st_size;
+	c->map = x;
+      }
+    }
+}
+
+int cdb_read(struct cdb *c,char *buf,unsigned int len,uint32 pos)
+{
+  if (c->map) {
+    if ((pos > c->size) || (c->size - pos < len)) goto FORMAT;
+    byte_copy(buf,len,c->map + pos);
+  }
+  else {
+    if (seek_set(c->fd,pos) == -1) return -1;
+    while (len > 0) {
+      int r;
+      do
+        r = read(c->fd,buf,len);
+      while ((r == -1) && (errno == error_intr));
+      if (r == -1) return -1;
+      if (r == 0) goto FORMAT;
+      buf += r;
+      len -= r;
+    }
+  }
+  return 0;
+
+  FORMAT:
+  errno = error_proto;
+  return -1;
+}
+
+static int match(struct cdb *c,const char *key,unsigned int len,uint32 pos)
+{
+  char buf[32];
+  unsigned int n;
+
+  while (len > 0) {
+    n = sizeof buf;
+    if (n > len) n = len;
+    if (cdb_read(c,buf,n,pos) == -1) return -1;
+    if (byte_diff(buf,n,key)) return 0;
+    pos += n;
+    key += n;
+    len -= n;
+  }
+  return 1;
+}
+
+int cdb_findnext(struct cdb *c,const char *key,unsigned int len)
+{
+  char buf[8];
+  uint32 pos;
+  uint32 u;
+
+  if (!c->loop) {
+    u = cdb_hash(key,len);
+    if (cdb_read(c,buf,8,(u << 3) & 2047) == -1) return -1;
+    uint32_unpack(buf + 4,&c->hslots);
+    if (!c->hslots) return 0;
+    uint32_unpack(buf,&c->hpos);
+    c->khash = u;
+    u >>= 8;
+    u %= c->hslots;
+    u <<= 3;
+    c->kpos = c->hpos + u;
+  }
+
+  while (c->loop < c->hslots) {
+    if (cdb_read(c,buf,8,c->kpos) == -1) return -1;
+    uint32_unpack(buf + 4,&pos);
+    if (!pos) return 0;
+    c->loop += 1;
+    c->kpos += 8;
+    if (c->kpos == c->hpos + (c->hslots << 3)) c->kpos = c->hpos;
+    uint32_unpack(buf,&u);
+    if (u == c->khash) {
+      if (cdb_read(c,buf,8,pos) == -1) return -1;
+      uint32_unpack(buf,&u);
+      if (u == len)
+	switch(match(c,key,len,pos + 8)) {
+	  case -1:
+	    return -1;
+	  case 1:
+	    uint32_unpack(buf + 4,&c->dlen);
+	    c->dpos = pos + 8 + len;
+	    return 1;
+	}
+    }
+  }
+
+  return 0;
+}
+
+int cdb_find(struct cdb *c,const char *key,unsigned int len)
+{
+  cdb_findstart(c);
+  return cdb_findnext(c,key,len);
+}
+
+int cdb_seek(struct cdb *c,const char *key,unsigned int len,uint32 *dlen)
+{
+  int rv;
+
+  rv = cdb_find(c, key, len);
+  if (rv != 1)
+    return rv;
+  *dlen = cdb_datalen(c);
+  return rv;
+}
+
diff -ruN qmail-1.03-orig/cdb.h qmail-1.03-ldap-20060201-orig/cdb.h
--- qmail-1.03-orig/cdb.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/cdb.h	2006-02-25 11:00:55.000000000 +0100
@@ -1,12 +1,40 @@
+/* Public domain. */
+
 #ifndef CDB_H
 #define CDB_H
 
 #include "uint32.h"
 
-extern uint32 cdb_hash();
-extern uint32 cdb_unpack();
+#define CDB_HASHSTART 5381
+extern uint32 cdb_hashadd(uint32,unsigned char);
+extern uint32 cdb_hash(const char *,unsigned int);
+
+struct cdb {
+  char *map; /* 0 if no map is available */
+  int fd;
+  uint32 size; /* initialized if map is nonzero */
+  uint32 loop; /* number of hash slots searched under this key */
+  uint32 khash; /* initialized if loop is nonzero */
+  uint32 kpos; /* initialized if loop is nonzero */
+  uint32 hpos; /* initialized if loop is nonzero */
+  uint32 hslots; /* initialized if loop is nonzero */
+  uint32 dpos; /* initialized if cdb_findnext() returns 1 */
+  uint32 dlen; /* initialized if cdb_findnext() returns 1 */
+} ;
+
+extern void cdb_free(struct cdb *);
+extern void cdb_init(struct cdb *,int fd);
+
+extern int cdb_read(struct cdb *,char *,unsigned int,uint32);
+
+extern void cdb_findstart(struct cdb *);
+extern int cdb_findnext(struct cdb *,const char *,unsigned int);
+extern int cdb_find(struct cdb *,const char *,unsigned int);
+extern int cdb_seek(struct cdb *,const char *,unsigned int,uint32 *);
 
-extern int cdb_bread();
-extern int cdb_seek();
+#define cdb_datapos(c) ((c)->dpos)
+#define cdb_datalen(c) ((c)->dlen)
+#define cdb_bread(c, b, l)	\
+	cdb_read((c), (b), (l), cdb_datapos(c))
 
 #endif
diff -ruN qmail-1.03-orig/cdb_hash.c qmail-1.03-ldap-20060201-orig/cdb_hash.c
--- qmail-1.03-orig/cdb_hash.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/cdb_hash.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,16 +1,21 @@
+/* Public domain. */
+
 #include "cdb.h"
 
-uint32 cdb_hash(buf,len)
-unsigned char *buf;
-unsigned int len;
+uint32 cdb_hashadd(uint32 h,unsigned char c)
+{
+  h += (h << 5);
+  return h ^ c;
+}
+
+uint32 cdb_hash(const char *buf,unsigned int len)
 {
   uint32 h;
 
-  h = 5381;
+  h = CDB_HASHSTART;
   while (len) {
+    h = cdb_hashadd(h,*buf++);
     --len;
-    h += (h << 5);
-    h ^= (uint32) *buf++;
   }
   return h;
 }
diff -ruN qmail-1.03-orig/cdb_make.c qmail-1.03-ldap-20060201-orig/cdb_make.c
--- qmail-1.03-orig/cdb_make.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/cdb_make.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,163 @@
+/* Public domain. */
+
+#include "readwrite.h"
+#include "seek.h"
+#include "error.h"
+#include "alloc.h"
+#include "cdb.h"
+#include "cdb_make.h"
+
+static void uint32_pack(char s[4],uint32 u)
+{
+  s[0] = u & 255;
+  u >>= 8;
+  s[1] = u & 255;
+  u >>= 8;
+  s[2] = u & 255;
+  s[3] = u >> 8;
+}
+
+int cdb_make_start(struct cdb_make *c,int fd)
+{
+  c->head = 0;
+  c->split = 0;
+  c->hash = 0;
+  c->numentries = 0;
+  c->fd = fd;
+  c->pos = sizeof c->final;
+  substdio_fdbuf(&c->ss,subwrite,fd,c->ssbuf,sizeof c->ssbuf);
+  return seek_set(fd,c->pos);
+}
+
+static int posplus(struct cdb_make *c,uint32 len)
+{
+  uint32 newpos = c->pos + len;
+  if (newpos < len) { errno = error_nomem; return -1; }
+  c->pos = newpos;
+  return 0;
+}
+
+int cdb_make_addend(struct cdb_make *c,unsigned int keylen,unsigned int datalen,uint32 h)
+{
+  struct cdb_hplist *head;
+
+  head = c->head;
+  if (!head || (head->num >= CDB_HPLIST)) {
+    head = (struct cdb_hplist *) alloc(sizeof(struct cdb_hplist));
+    if (!head) return -1;
+    head->num = 0;
+    head->next = c->head;
+    c->head = head;
+  }
+  head->hp[head->num].h = h;
+  head->hp[head->num].p = c->pos;
+  ++head->num;
+  ++c->numentries;
+  if (posplus(c,8) == -1) return -1;
+  if (posplus(c,keylen) == -1) return -1;
+  if (posplus(c,datalen) == -1) return -1;
+  return 0;
+}
+
+int cdb_make_addbegin(struct cdb_make *c,unsigned int keylen,unsigned int datalen)
+{
+  char buf[8];
+
+  if (keylen > 0xffffffff) { errno = error_nomem; return -1; }
+  if (datalen > 0xffffffff) { errno = error_nomem; return -1; }
+
+  uint32_pack(buf,keylen);
+  uint32_pack(buf + 4,datalen);
+  if (substdio_put(&c->ss,buf,8) == -1) return -1;
+  return 0;
+}
+
+int cdb_make_add(struct cdb_make *c,const char *key,unsigned int keylen,const char *data,unsigned int datalen)
+{
+  if (cdb_make_addbegin(c,keylen,datalen) == -1) return -1;
+  if (substdio_put(&c->ss,key,keylen) == -1) return -1;
+  if (substdio_put(&c->ss,data,datalen) == -1) return -1;
+  return cdb_make_addend(c,keylen,datalen,cdb_hash(key,keylen));
+}
+
+int cdb_make_finish(struct cdb_make *c)
+{
+  char buf[8];
+  int i;
+  uint32 len;
+  uint32 u;
+  uint32 memsize;
+  uint32 count;
+  uint32 where;
+  struct cdb_hplist *x;
+  struct cdb_hp *hp;
+
+  for (i = 0;i < 256;++i)
+    c->count[i] = 0;
+
+  for (x = c->head;x;x = x->next) {
+    i = x->num;
+    while (i--)
+      ++c->count[255 & x->hp[i].h];
+  }
+
+  memsize = 1;
+  for (i = 0;i < 256;++i) {
+    u = c->count[i] * 2;
+    if (u > memsize)
+      memsize = u;
+  }
+
+  memsize += c->numentries; /* no overflow possible up to now */
+  u = (uint32) 0 - (uint32) 1;
+  u /= sizeof(struct cdb_hp);
+  if (memsize > u) { errno = error_nomem; return -1; }
+
+  c->split = (struct cdb_hp *) alloc(memsize * sizeof(struct cdb_hp));
+  if (!c->split) return -1;
+
+  c->hash = c->split + c->numentries;
+
+  u = 0;
+  for (i = 0;i < 256;++i) {
+    u += c->count[i]; /* bounded by numentries, so no overflow */
+    c->start[i] = u;
+  }
+
+  for (x = c->head;x;x = x->next) {
+    i = x->num;
+    while (i--)
+      c->split[--c->start[255 & x->hp[i].h]] = x->hp[i];
+  }
+
+  for (i = 0;i < 256;++i) {
+    count = c->count[i];
+
+    len = count + count; /* no overflow possible */
+    uint32_pack(c->final + 8 * i,c->pos);
+    uint32_pack(c->final + 8 * i + 4,len);
+
+    for (u = 0;u < len;++u)
+      c->hash[u].h = c->hash[u].p = 0;
+
+    hp = c->split + c->start[i];
+    for (u = 0;u < count;++u) {
+      where = (hp->h >> 8) % len;
+      while (c->hash[where].p)
+	if (++where == len)
+	  where = 0;
+      c->hash[where] = *hp++;
+    }
+
+    for (u = 0;u < len;++u) {
+      uint32_pack(buf,c->hash[u].h);
+      uint32_pack(buf + 4,c->hash[u].p);
+      if (substdio_put(&c->ss,buf,8) == -1) return -1;
+      if (posplus(c,8) == -1) return -1;
+    }
+  }
+
+  if (substdio_flush(&c->ss) == -1) return -1;
+  if (seek_begin(c->fd) == -1) return -1;
+  return substdio_putflush(&c->ss,c->final,sizeof c->final);
+}
diff -ruN qmail-1.03-orig/cdb_make.h qmail-1.03-ldap-20060201-orig/cdb_make.h
--- qmail-1.03-orig/cdb_make.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/cdb_make.h	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,39 @@
+/* Public domain. */
+
+#ifndef CDB_MAKE_H
+#define CDB_MAKE_H
+
+#include "substdio.h"
+#include "uint32.h"
+
+#define CDB_HPLIST 1000
+
+struct cdb_hp { uint32 h; uint32 p; } ;
+
+struct cdb_hplist {
+  struct cdb_hp hp[CDB_HPLIST];
+  struct cdb_hplist *next;
+  int num;
+} ;
+
+struct cdb_make {
+  char ssbuf[8192];
+  char final[2048];
+  uint32 count[256];
+  uint32 start[256];
+  struct cdb_hplist *head;
+  struct cdb_hp *split; /* includes space for hash */
+  struct cdb_hp *hash;
+  uint32 numentries;
+  substdio ss;
+  uint32 pos;
+  int fd;
+} ;
+
+extern int cdb_make_start(struct cdb_make *,int);
+extern int cdb_make_addbegin(struct cdb_make *,unsigned int,unsigned int);
+extern int cdb_make_addend(struct cdb_make *,unsigned int,unsigned int,uint32);
+extern int cdb_make_add(struct cdb_make *,const char *,unsigned int,const char *,unsigned int);
+extern int cdb_make_finish(struct cdb_make *);
+
+#endif
diff -ruN qmail-1.03-orig/check.c qmail-1.03-ldap-20060201-orig/check.c
--- qmail-1.03-orig/check.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/check.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,282 @@
+/*
+ * Copyright (c) 1998-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#include "qmail-ldap.h"
+#include "check.h"
+#include "str.h"
+
+extern unsigned char testvektor[128];
+
+/* XXX this is not a security checker, it just looks that no special chars 
+ * XXX are in the string this is because the ldap server could send some 
+ * XXX faked datas */
+int sanitycheckb(char *s, unsigned int len, unsigned char mask)
+{
+	unsigned char *tv;
+	unsigned int x;
+
+	tv = testvektor;
+	
+	x = (unsigned int)*s++; if (!len--) return 1;
+	/* is this char allowed as first char (normaly '-' is not) */
+	if (x > 0x7F || !(tv[x] & mask) || tv[x] & NOT_FIRST) return 0;
+
+	for (;;) {
+		x = (unsigned int)*s++; if (!len--) return 1;
+		if (x > 0x7F || !(tv[x] & mask)) return 0;
+		x = (unsigned int)*s++; if (!len--) return 1;
+		if (x > 0x7F || !(tv[x] & mask)) return 0;
+		x = (unsigned int)*s++; if (!len--) return 1;
+		if (x > 0x7F || !(tv[x] & mask)) return 0;
+		x = (unsigned int)*s++; if (!len--) return 1;
+		if (x > 0x7F || !(tv[x] & mask)) return 0;
+	}
+	return 0; /* paranoia */
+}
+
+/* XXX this is not a security checker, it just looks that no special chars 
+ * XXX are in the string this is because the ldap server could send some 
+ * XXX faked datas */
+int sanitypathcheckb(char *s, unsigned int len, unsigned char mask)
+/* works like sanitycheckb but also looks that there is no '..' in the
+ * string. This should be used for maildirpaths */
+{
+	unsigned char *tv;
+	unsigned int x;
+	enum { NODOT, FIRST, SLASH, ONEDOT, TWODOT } state = FIRST;
+
+	tv = testvektor;
+	
+	while (len--) {
+		x = (unsigned int)*s++;
+		if (x > 0x7F || !(tv[x] & mask)) return 0;
+		if (state == FIRST && tv[x] & NOT_FIRST) return 0;
+		switch (x) {
+		case '.':
+			switch (state) {
+			case ONEDOT:
+				state = TWODOT;
+				break;
+			case NODOT:
+				break;
+			default:
+				state = ONEDOT;
+			}
+			break;
+		case '/':
+			if (state == TWODOT)
+				return 0;
+			state = SLASH;
+			break;
+		default:
+			state = NODOT;
+			break;
+		}
+	}
+	return 1;
+}
+
+int sanitychecks(register char *s, register unsigned char mask) 
+{
+	return sanitycheckb(s, str_len(s), mask);
+}
+
+int sanitypathchecks(register char *s, register unsigned char mask) 
+{
+	return sanitypathcheckb(s, str_len(s), mask);
+}
+
+/************************************************************
+You can allow or deny chars by adding:
+  DENY_ALL:   always deny this char
+  ALLOW_ALL:  always allow this char
+  ALLOW_USER: allow this char for username checks (chck_user)
+  DENY_USER:  deny this char for username checks (chck_user)
+  ALLOW_PATH: allow this char for path checks (chck_path)
+  DENY_PATH:  deny this char for path checks (chck_path)
+  ALLOW_PROG: allow this char for program checks (chck_prog)
+  DENY_PROG:  deny this char for program checks (chck_prog)
+  NOT_FIRST:  deny this char at the beginning of a string
+  SPACE:      alias to ALLOW_PROG
+  PARANOIA:   deny most shell special chars like '|' or '*' for program checks
+              can be turned on or of in qmail-ldap.h
+  Example:
+   * 7  \007 ^G * DENY_ALL,               * deny control chars *
+   * 45 '-'     * ALLOW_ALL|NOT_FIRST,    * allowed but not first *
+   * 47 '/'     * ALLOW_ALL&DENY_USER,    * allowed only for path and prog *
+   * 58 ':'     * ALLOW_PROG|ALLOW_PATH,  * like before *
+ 
+  As you can see ALLOWs have to be ORed together whereas DENYs have to be ANDed
+  NOT_FIRST has to be ORed and PARANOIA has to be ANDed.
+
+************************************************************/
+
+unsigned char testvektor[128] = { 
+#define SPACE			ALLOW_PROG
+#if RESTRICT_PROG == 1
+# define PARANOIA		DENY_PROG
+#else
+# define PARANOIA		0xFF
+#endif
+	/* nr	char		*/
+	/********************/
+	/* 0	\000	^@	*/	DENY_ALL,
+	/* 1	\001	^A	*/	DENY_ALL,
+	/* 2	\002	^B	*/	DENY_ALL,
+	/* 3	\003	^C	*/	DENY_ALL,
+	/* 4	\004	^D	*/	DENY_ALL,
+	/* 5	\005	^E	*/	DENY_ALL,
+	/* 6	\006	^F	*/	DENY_ALL,
+	/* 7	\007	^G	*/	DENY_ALL,
+	/* 8	\010	^F	*/	DENY_ALL,
+	/* 9	\011	\t	*/	SPACE,
+	/* 10	\012	\n	*/	SPACE,
+	/* 11	\013	^K	*/	DENY_ALL,
+	/* 12	\014	^L	*/	DENY_ALL,
+	/* 13	\015	^M	*/	DENY_ALL,
+	/* 14	\016	^N	*/	DENY_ALL,
+	/* 15	\017	^O	*/	DENY_ALL,
+	/* 16	\020	^P	*/	DENY_ALL,
+	/* 17	\021	^Q	*/	DENY_ALL,
+	/* 18	\022	^R	*/	DENY_ALL,
+	/* 19	\023	^S	*/	DENY_ALL,
+	/* 20	\024	^T	*/	DENY_ALL,
+	/* 21	\025	^U	*/	DENY_ALL,
+	/* 22	\026	^V	*/	DENY_ALL,
+	/* 23	\027	^W	*/	DENY_ALL,
+	/* 24	\030	^X	*/	DENY_ALL,
+	/* 25	\031	^Y	*/	DENY_ALL,
+	/* 26	\032	^Z	*/	DENY_ALL,
+	/* 27	\033	ESC	*/	DENY_ALL,
+	/* 28	\034	^\	*/	DENY_ALL,
+	/* 29	\035	^]	*/	DENY_ALL,
+	/* 30	\036	^^	*/	DENY_ALL,
+	/* 31	\037	^_	*/	DENY_ALL,
+	/* 32	' '			*/	SPACE,
+	/* 33	'!'			*/	ALLOW_PROG&PARANOIA,
+	/* 34	'"'			*/	ALLOW_PROG,
+	/* 35	'#'			*/	ALLOW_ALL,
+	/* 36	'$'			*/	ALLOW_PROG&PARANOIA,
+	/* 37	'%'			*/	ALLOW_PROG&PARANOIA,
+	/* 38	'&'			*/	ALLOW_PROG&PARANOIA,
+	/* 39	'''			*/	ALLOW_PROG,
+	/* 40	'('			*/	ALLOW_PROG&PARANOIA,
+	/* 41	')'			*/	ALLOW_PROG&PARANOIA,
+	/* 42	'*'			*/	ALLOW_PROG&PARANOIA,
+	/* 43	'+'			*/	ALLOW_PROG,
+	/* 44	','			*/	ALLOW_PROG,
+	/* 45	'-'			*/	ALLOW_ALL|NOT_FIRST, /*XXX*/
+	/* 46	'.'			*/	ALLOW_ALL,
+	/* 47	'/'			*/	ALLOW_ALL&DENY_USER,
+	/* 48	'0'			*/	ALLOW_ALL,
+	/* 49	'1'			*/	ALLOW_ALL,
+	/* 50	'2'			*/	ALLOW_ALL,
+	/* 51	'3'			*/	ALLOW_ALL,
+	/* 52	'4'			*/	ALLOW_ALL,
+	/* 53	'5'			*/	ALLOW_ALL,
+	/* 54	'6'			*/	ALLOW_ALL,
+	/* 55	'7'			*/	ALLOW_ALL,
+	/* 56	'8'			*/	ALLOW_ALL,
+	/* 57	'9'			*/	ALLOW_ALL,
+	/* 58	':'			*/	ALLOW_PROG|ALLOW_PATH,
+	/* 59	';'			*/	ALLOW_PROG&PARANOIA,
+	/* 60	'<'			*/	ALLOW_PROG&PARANOIA,
+	/* 61	'='			*/	ALLOW_PROG|ALLOW_PATH,
+	/* 62	'>'			*/	ALLOW_PROG&PARANOIA,
+	/* 63	'?'			*/	ALLOW_PROG&PARANOIA,
+	/* 64	'@'			*/	ALLOW_USER|ALLOW_PATH|ALLOW_PROG, /*XXX*/
+	/* 65	'A'			*/	ALLOW_ALL,
+	/* 66	'B'			*/	ALLOW_ALL,
+	/* 67	'C'			*/	ALLOW_ALL,
+	/* 68	'D'			*/	ALLOW_ALL,
+	/* 69	'E'			*/	ALLOW_ALL,
+	/* 70	'F'			*/	ALLOW_ALL,
+	/* 71	'G'			*/	ALLOW_ALL,
+	/* 72	'H'			*/	ALLOW_ALL,
+	/* 73	'I'			*/	ALLOW_ALL,
+	/* 74	'J'			*/	ALLOW_ALL,
+	/* 75	'K'			*/	ALLOW_ALL,
+	/* 76	'L'			*/	ALLOW_ALL,
+	/* 77	'M'			*/	ALLOW_ALL,
+	/* 78	'N'			*/	ALLOW_ALL,
+	/* 79	'O'			*/	ALLOW_ALL,
+	/* 80	'P'			*/	ALLOW_ALL,
+	/* 81	'Q'			*/	ALLOW_ALL,
+	/* 82	'R'			*/	ALLOW_ALL,
+	/* 83	'S'			*/	ALLOW_ALL,
+	/* 84	'T'			*/	ALLOW_ALL,
+	/* 85	'U'			*/	ALLOW_ALL,
+	/* 86	'V'			*/	ALLOW_ALL,
+	/* 87	'W'			*/	ALLOW_ALL,
+	/* 88	'X'			*/	ALLOW_ALL,
+	/* 89	'Y'			*/	ALLOW_ALL,
+	/* 90	'Z'			*/	ALLOW_ALL,
+	/* 91	'['			*/	ALLOW_PROG&PARANOIA,
+	/* 92	'\\'			*/	ALLOW_PROG,
+	/* 93	']'			*/	ALLOW_PROG&PARANOIA,
+	/* 94	'^'			*/	ALLOW_PROG&PARANOIA,
+	/* 95	'_'			*/	ALLOW_ALL,
+	/* 96	'`'			*/	ALLOW_PROG&PARANOIA,
+	/* 97	'a'			*/	ALLOW_ALL,
+	/* 98	'b'			*/	ALLOW_ALL,
+	/* 99	'c'			*/	ALLOW_ALL,
+	/* 100	'd'			*/	ALLOW_ALL,
+	/* 101	'e'			*/	ALLOW_ALL,
+	/* 102	'f'			*/	ALLOW_ALL,
+	/* 103	'g'			*/	ALLOW_ALL,
+	/* 104	'h'			*/	ALLOW_ALL,
+	/* 105	'i'			*/	ALLOW_ALL,
+	/* 106	'j'			*/	ALLOW_ALL,
+	/* 107	'k'			*/	ALLOW_ALL,
+	/* 108	'l'			*/	ALLOW_ALL,
+	/* 109	'm'			*/	ALLOW_ALL,
+	/* 110	'n'			*/	ALLOW_ALL,
+	/* 111	'o'			*/	ALLOW_ALL,
+	/* 112	'p'			*/	ALLOW_ALL,
+	/* 113	'q'			*/	ALLOW_ALL,
+	/* 114	'r'			*/	ALLOW_ALL,
+	/* 115	's'			*/	ALLOW_ALL,
+	/* 116	't'			*/	ALLOW_ALL,
+	/* 117	'u'			*/	ALLOW_ALL,
+	/* 118	'v'			*/	ALLOW_ALL,
+	/* 119	'w'			*/	ALLOW_ALL,
+	/* 120	'x'			*/	ALLOW_ALL,
+	/* 121	'y'			*/	ALLOW_ALL,
+	/* 122	'z'			*/	ALLOW_ALL,
+	/* 123	'{'			*/	ALLOW_PROG&PARANOIA,
+	/* 124	'|'			*/	ALLOW_PROG&PARANOIA,
+	/* 125	'}'			*/	ALLOW_PROG&PARANOIA,
+	/* 126	'~'			*/	ALLOW_PROG&PARANOIA,
+	/* 127	^?			*/	DENY_ALL
+};
+
diff -ruN qmail-1.03-orig/check.h qmail-1.03-ldap-20060201-orig/check.h
--- qmail-1.03-orig/check.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/check.h	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,64 @@
+/*
+ * Copyright (c) 1998-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#ifndef _CHECK_H_
+#define _CHECK_H_
+
+
+#define DENY_ALL	0x00
+#define ALLOW_USER	0x01
+#define ALLOW_PATH	0x02
+#define ALLOW_PROG	0x04
+#define ALLOW_ALL	(ALLOW_USER | ALLOW_PATH | ALLOW_PROG)
+#define DENY_USER	(unsigned char) ~ALLOW_USER
+#define DENY_PATH	(unsigned char) ~ALLOW_PATH
+#define DENY_PROG	(unsigned char) ~ALLOW_PROG
+#define NOT_FIRST	0x80
+
+
+extern int sanitycheckb(char *, unsigned int, unsigned char);
+extern int sanitychecks(char *, unsigned char);
+
+extern int sanitypathcheckb(char *, unsigned int , unsigned char);
+extern int sanitypathchecks(char *, unsigned char);
+
+#define check_userb(str, len)	sanitycheckb((str), (len), ALLOW_USER)
+#define check_users(str)	sanitychecks((str), ALLOW_USER)
+
+#define check_pathb(str, len)	sanitypathcheckb((str), (len), ALLOW_PATH)
+#define check_paths(str)	sanitypathchecks((str), ALLOW_PATH)
+
+#define check_progb(str, len)	sanitycheckb((str), (len), ALLOW_PROG)
+#define check_progs(str)	sanitychecks((str), ALLOW_PROG)
+
+#endif
